package com.pretius.springBootJettyExample.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.pretius.springBootJettyExample.domain.Parameter;
import com.pretius.springBootJettyExample.domain.service.ParameterRepository;

@RestController
public class ParamController {

	@Autowired
	ParameterRepository paramRepo;

    @RequestMapping("/")
    String home() {
        return "Greetings from Pretius!";
    }

    @RequestMapping(value="/get/{param}", method=RequestMethod.GET)
    String getParam(@PathVariable("param") String param) {
        Parameter ret =paramRepo.findByName(param);
        
    	return buildGetParamResponse(param, ret);
    }

	private String buildGetParamResponse(String param, Parameter ret) {
		StringBuilder resp = new StringBuilder();
    	resp.append("param '").append(param).append("' value: ");
        if (ret == null || ret.getVal() == null) {
        	resp.append("&lt;not set&gt;");
        } else {
        	resp.append("'").append(ret.getVal()).append("'");
        }
        return resp.toString();
	}

    @RequestMapping(value="/set/{param}/{value}", method=RequestMethod.GET)
    String insertParam(@PathVariable("param") String param, @PathVariable("value") String value) {
    	paramRepo.save(new Parameter(param, value));
    	
    	return buildInsertParamResponse(param, value);
    }

    private String buildInsertParamResponse(String param, String value) {
		return "param '"+param+"' set to value '"+value+"'";
	}


}
